Holger's Java API

## com.antelmann.db
Class JUserLoginPanel

    java.lang.Object
      java.awt.Component
          java.awt.Container
              javax.swing.JComponent
                  com.antelmann.db.JUserLoginPanel

All Implemented Interfaces:
  ActionListener, ImageObserver, MenuContainer, Serializable, EventListener

    public class JUserLoginPanel

extends JComponent
implements ActionListener

a component to be used for user logins

Author:
  Holger Antelmann
See Also:
  Serialized Form

Nested Class Summary
`static class` `JUserLoginPanel.ImageLocation`

Nested classes/interfaces inherited from class javax.swing.JComponent
`JComponent.AccessibleJComponent`

Nested classes/interfaces inherited from class java.awt.Container
`Container.AccessibleAWTContainer`

Nested classes/interfaces inherited from class java.awt.Component
`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

Field Summary
`static String` `LOGIN_KEY`

Fields inherited from class javax.swing.JComponent
`accessibleContext, listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

Fields inherited from class java.awt.Component
`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

Fields inherited from interface java.awt.image.ImageObserver
`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

Constructor Summary
`JUserLoginPanel(UserLoginStore uls, String location)`
`JUserLoginPanel(UserLoginStore uls, String location, Image image, JUserLoginPanel.ImageLocation imageLocation)`
`JUserLoginPanel(UserLoginStore uls, String location, Image image, JUserLoginPanel.ImageLocation imageLocation, String userString, String pwdString)`

Method Summary
`void` `actionPerformed(ActionEvent ev)` implements the action when the login button is pressed or ENTER is pressed on either user name or password field.
`static String` `getDefaultLocation()` attempts to get the name of the local host and returns a default string if this fails
`Exception` `getException()` returns either a DatabaseException or a javax.security.auth.login.FailedLoginException
`User` `getUser()` returns the user (if any) that was identified after the component was acted upon
`boolean` `isClearUserOnChange()`
`void` `setClearUserOnChange(boolean clearUserOnChange)`
`void` `setPassword(String password)`
`void` `setUserName(String userName)`
`static User` `showDialog(String title, Component parent, UserLoginStore uls)` uses the default location
`static User` `showDialog(String title, Component parent, UserLoginStore uls, Image image, JUserLoginPanel.ImageLocation imageLocation)`
`static User` `showDialog(String title, Component parent, UserLoginStore uls, String location)`
`static User` `showDialog(String title, Component parent, UserLoginStore uls, String location, Image image, JUserLoginPanel.ImageLocation imageLocation)`
`static User` `showDialog(String title, Component parent, UserLoginStore uls, String location, Image image, JUserLoginPanel.ImageLocation imageLocation, String userString, String pwdString)` Upon successful login, the associated user is logged into the UserLoginStore.

Methods inherited from class javax.swing.JComponent

`addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getAccessibleContext, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getUIClassID, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, paramString, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update, updateUI`

Methods inherited from class java.awt.Container

`add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusBackward, transferFocusDownCycle, validate, validateTree`

Methods inherited from class java.awt.Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, hide, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusUpCycle`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### LOGIN_KEY

    public static final String LOGIN_KEY

See Also:
  Constant Field Values

Constructor Detail

### JUserLoginPanel

    public JUserLoginPanel(UserLoginStore uls,
                           String location)

### JUserLoginPanel

    public JUserLoginPanel(UserLoginStore uls,
                           String location,
                           Image image,
                           JUserLoginPanel.ImageLocation imageLocation)

### JUserLoginPanel

    public JUserLoginPanel(UserLoginStore uls,
                           String location,
                           Image image,
                           JUserLoginPanel.ImageLocation imageLocation,
                           String userString,
                           String pwdString)

Method Detail

### setUserName

    public void setUserName(String userName)

### setPassword

    public void setPassword(String password)

### isClearUserOnChange

    public boolean isClearUserOnChange()

### setClearUserOnChange

    public void setClearUserOnChange(boolean clearUserOnChange)

### actionPerformed

    public void actionPerformed(ActionEvent ev)

  implements the action when the login button is pressed or ENTER is pressed on either user name or password field. Upon successful login, the associated user is logged into the UserLoginStore. Depending on what happened, the values for user and exception are set.

  Specified by:
    `actionPerformed` in interface `ActionListener`
  See Also:
    `getException()`, `getUser()`

### getUser

    public User getUser()

  returns the user (if any) that was identified after the component was acted upon

### getException

    public Exception getException()

  returns either a DatabaseException or a javax.security.auth.login.FailedLoginException

### showDialog

    public static User showDialog(String title,
                                  Component parent,
                                  UserLoginStore uls)
                           throws DatabaseException

  uses the default location

  Throws:
    `DatabaseException`
  See Also:
    `getDefaultLocation()`

### showDialog

    public static User showDialog(String title,
                                  Component parent,
                                  UserLoginStore uls,
                                  String location)
                           throws DatabaseException

  Throws:
    `DatabaseException`

### showDialog

    public static User showDialog(String title,
                                  Component parent,
                                  UserLoginStore uls,
                                  Image image,
                                  JUserLoginPanel.ImageLocation imageLocation)
                           throws DatabaseException

  Throws:
    `DatabaseException`

### showDialog

    public static User showDialog(String title,
                                  Component parent,
                                  UserLoginStore uls,
                                  String location,
                                  Image image,
                                  JUserLoginPanel.ImageLocation imageLocation)
                           throws DatabaseException

  Throws:
    `DatabaseException`

### showDialog

    public static User showDialog(String title,
                                  Component parent,
                                  UserLoginStore uls,
                                  String location,
                                  Image image,
                                  JUserLoginPanel.ImageLocation imageLocation,
                                  String userString,
                                  String pwdString)
                           throws DatabaseException

  Upon successful login, the associated user is logged into the UserLoginStore. On every failed login attempt, the waiting period is extended by one second. If an Exception is thrown (other than FailedLoginException), the listeners of the UserLoginStore are informed, so that they might react appropriately; the dialog would currently simply show a warning on pressing OK in this case, so that one would only get out of the dialog via CANCEL.

  Throws:
    `DatabaseException`

### getDefaultLocation

    public static String getDefaultLocation()

  attempts to get the name of the local host and returns a default string if this fails

(c) Holger Antelmann since 2001- all rights reserved (contact: info@antelmann.com)
see www.antelmann.com/developer for further details and available downloads